var Ci = Components.interfaces;

var asw = {
  init: function() {
	  try { if(window.arguments[0]) window.opener=window.arguments[0]; } catch(e){}
	  this.prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		this.sandbox=new Array(new Array(),new Array(),new Array());
		this.mayChange=false;
		
		min=this.prefs.getIntPref ('browser.search.minwidth');
    max=this.prefs.getIntPref ('browser.search.maxwidth');
    off=this.prefs.getIntPref ('browser.search.offset');  
    document.getElementById('cleanSearchbar').checked=this.prefs.getBoolPref('browser.search.cleanOnSubmit');
		// Load prefs
		
		
		if(min==0 && max==off) {
		  path=1; // Alternative
			asw.text2desc('altWidthPixels',this.lang('altWidth',max),false);
		  this.sandbox[1][0]=0;
			this.sandbox[1][1]=max;
			this.sandbox[1][2]=max;
			// Guessing for fixed
			this.sandbox[2][0]=max;
			this.sandbox[2][1]=max;
			this.sandbox[2][2]=off;
			// Guessing for normal
			this.sandbox[0][1]=max;
			this.sandbox[0][0]=0;
		} else if(min==max && min!=0) {
		  path=2; // Fixed
			asw.text2desc('fixWidthPixels',this.lang('fixWidth',min),false);
		  this.sandbox[2][0]=min;
			this.sandbox[2][1]=min;
			this.sandbox[2][2]=off;
			// Guessing for alt
			this.sandbox[1][0]=0;
			this.sandbox[1][1]=min;
			this.sandbox[1][2]=min;
			// Guessing for normal
			this.sandbox[0][1]=min;
			this.sandbox[0][0]=0;
		} else {
		  path=0; // normal
			
			if(min==0) {
			  asw.text2desc('norMinWidthPixels',this.lang('minWidthTitle',''),false);
			  this.sandbox[0][0]=0;
			} else if(min==1) {
			  asw.text2desc('norMinWidthPixels',this.lang('minWidthSmall',''),false);
			  this.sandbox[0][0]=1;
			} else {
			  asw.text2desc('norMinWidthPixels',this.lang('minWidthPx',min),false);
		    this.sandbox[0][0]=min;
			}
			
			if(max==0) {
			  asw.text2desc('norMaxWidthPixels',this.lang('maxWidthWide',''),false);
			  this.sandbox[0][1]=0;
			} else {
			  asw.text2desc('norMaxWidthPixels',this.lang('maxWidthPx',max),false);
		    this.sandbox[0][1]=max;
				// Guessing for alt
				this.sandbox[1][0]=0;
				this.sandbox[1][1]=max;
				this.sandbox[1][2]=max;
				// Guessing for fixed
				this.sandbox[2][0]=max;
				this.sandbox[2][1]=max;
				this.sandbox[2][2]=off;
			}			
			this.sandbox[2][2]=off;
		}
		
		document.getElementById('startBehaviour').selectedIndex=path;
		
		// Enable extra2 button manually
		extra2=document.getElementById('autosizer-install-wizard').getButton('extra2');
		extra2.removeAttribute('hidden');
		extra2.setAttribute('onclick',"window.openDialog('chrome://autosizer/content/prefs.xul', '_blank', 'chrome,titlebar,toolbar,centerscreen,dialog=no',window.opener);window.close();");
		extra2.label=this.lang('buttonAdvanced','');
		extra2.setAttribute('accesskey',this.lang('buttonAdvancedAccesskey',''));
	},
	
	lang: function(v,t) {
	  return document.getElementById("locale").getFormattedString(v, [t+'']);	
	},
	
	nextPageOnFirstPage: function() {
	  nextItemVal=document.getElementById('startBehaviour').selectedItem.value;
		if(nextItemVal=='normal') newPage='norMinWidth';
	  if(nextItemVal=='alternative') newPage='altWidth';		
		if(nextItemVal=='fixed') newPage='fixWidth';
	  document.getElementById('start').setAttribute('next',newPage);
	},

	canAdv: function(what) { 
	  document.getElementById('autosizer-install-wizard').canAdvance=what;
	},

	toggleSizing: function(what) { 	 
		asw.makeOnTop(what);	
	  
		if (this.prefs instanceof Components.interfaces.nsIPrefBranchInternal) {
			var prefObserver = new AutosizerWizPrefObserver();
			if (what) this.prefs.addObserver('', prefObserver, false);
			else this.prefs.removeObserver('', prefObserver);
		}	   
		this.mayChange=what;
		if(what) {
			curPage=document.getElementById('autosizer-install-wizard').currentPage.pageid;	
			var value='nosize';
			if(curPage=='altWidth' && this.sandbox[1][1]) value=this.sandbox[1][1]+'';
			if(curPage=='fixWidth' && this.sandbox[2][1]) value=this.sandbox[2][1]+'';		
		  if(curPage=='norMinWidth' && this.sandbox[0][0]) {
			  if(this.sandbox[0][0]==0) value='label';
				else value=this.sandbox[0][0];
			}  
			if(curPage=='norMaxWidth' && this.sandbox[0][1]) {
			  if(this.sandbox[0][1]==0) value='max';
				else value=this.sandbox[0][1];
			}  		

		  this.prefs.setCharPref('browser.search.manualResize',value);	
			
		} else this.prefs.setCharPref('browser.search.manualResize','');
		this.prefs.setCharPref('browser.search.autosizerwizard','');
		
		
		if(what) {
		  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			var win = wm.getMostRecentWindow("navigator:browser");
			if(win) win.focus();
			else {
			  this.win=window.openDialog("chrome://browser/content/", "_blank", "chrome,all,dialog=no");
				setTimeout('asw.win._content.location="about:blank";',0);
			} 
			setTimeout("window.focus()",1);
		}
		
		// Displaying the grippys is handled in autosizer.js checkPrefs function.
	},
	
	text2desc: function(id,text,bold) {
	  d=document.getElementById(id);
		if(d.hasChildNodes())
		  d.replaceChild(document.createTextNode(text),d.firstChild);
		else
		  d.appendChild(document.createTextNode(text));
		d.removeAttribute("value"); // Strangely it seems to appear from nowhere?!
		if(bold) d.setAttribute("style","font-weight:bold;");
	},

	manualSizingChange: function() {
	  if(!this.mayChange) return;
	  try {
			newValue=this.prefs.getCharPref('browser.search.autosizerwizard');
			newValue=newValue.split('|');
			if(newValue[0]==0 || newValue[0] == undefined) return;
			// width neededWidth tooltipwidth availableWidth
		} catch(e) { return; }
		this.canAdv(true);
		
		curPage=document.getElementById('autosizer-install-wizard').currentPage.pageid;	
		if(curPage=='altWidth') {
		  asw.text2desc('altWidthPixels',this.lang('altWidthChange',newValue[0]),true);
		  this.sandbox[1][0]=0;
			this.sandbox[1][1]=newValue[0];
			this.sandbox[1][2]=newValue[0];
		}
		
		if(curPage=='fixWidth') {
			asw.text2desc('fixWidthPixels',this.lang('fixWidthChange',newValue[0]),true);
		  this.sandbox[2][0]=newValue[0];
			this.sandbox[2][1]=newValue[0];
			this.sandbox[2][2]=0;
		}
		
	  if(curPage=='norMinWidth') {
		  this.sandbox[0][2]=0;
		  if(newValue[0]<newValue[1]*1+5) {
			  asw.text2desc('norMinWidthPixels',this.lang('minWidthSmallChange',''),true);
			  this.sandbox[0][0]=1;
			} else if(newValue[0]<newValue[2]*1+15 && newValue[0]>newValue[2]*1-15) {
			  asw.text2desc('norMinWidthPixels',this.lang('minWidthTitleChange',''),true);
			  this.sandbox[0][0]=0;
			} else {
			  asw.text2desc('norMinWidthPixels',this.lang('minWidthPxChange',newValue[0]),true);
		    this.sandbox[0][0]=newValue[0];
			}
		}
		
		if(curPage=='norMaxWidth') {
		  if(newValue[0]>newValue[3]*1-70) {
				asw.text2desc('norMaxWidthPixels',this.lang('maxWidthWideChange',''),true);
			  this.sandbox[0][1]=0;
			} else {
				asw.text2desc('norMaxWidthPixels',this.lang('maxWidthPxChange',newValue[0]),true);
		    this.sandbox[0][1]=newValue[0];
			}
		}
	},
	
	makeOnTop: function(what) {
	  // Thanks to console2 extension :)
		try {
		  var xulWin = window.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation).QueryInterface(Ci.nsIDocShellTreeItem).treeOwner.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIXULWindow);
			xulWin.zLevel = (what)?xulWin.raisedZ:xulWin.normalZ;
		} catch(e) {}
	},
  
	savePrefs: function () {
	  path=document.getElementById('startBehaviour').selectedIndex;
	  this.prefs.setIntPref ('browser.search.minwidth',     this.sandbox[path][0]);
    this.prefs.setIntPref ('browser.search.maxwidth',     this.sandbox[path][1]);
    this.prefs.setIntPref ('browser.search.offset',       this.sandbox[path][2]);  
    this.prefs.setBoolPref('browser.search.cleanOnSubmit',document.getElementById('cleanSearchbar').checked);
		
		// Reset other prefs here
		this.prefs.setIntPref ('browser.search.labelOffset',2); 
		this.prefs.setIntPref ('browser.search.autocompletePopupMinWidth',200); 
		
		asw.cleanUp();
	},
	
	cleanUp: function() {
	  this.toggleSizing(false);
		this.prefs.setCharPref('browser.search.autosizerwizard',''); 
		try { window.opener.focus(); } catch(e) {}
	}
}

function AutosizerWizPrefObserver() {
	asw.manualSizingChange();
}

AutosizerWizPrefObserver.prototype = {
  observe: function(subject, topic, pref) {
		if (topic == 'nsPref:changed' && pref=='browser.search.autosizerwizard') {
		  try { asw.manualSizingChange(); } catch(e) {}
		}
	}
};